Don't initialise disk_* for the sim, and make sure disk.c isn't built at all
[kugel-rb.git] / tools / rockboxdev.sh
blobf487fe01c43e593beb13274bc68597c9f27221a6
1 #!/bin/sh
3 # Abort execution as soon as an error is encountered
4 # That way the script do not let the user think the process completed correctly
5 # and leave the opportunity to fix the problem and restart compilation where
6 # it stopped
7 set -e
9 # this is where this script will store downloaded files and check for already
10 # downloaded files
11 dlwhere="${RBDEV_DOWNLOAD:-/tmp/rbdev-dl}"
13 # will append the target string to the prefix dir mentioned here
14 # Note that the user running this script must be able to do make install in
15 # this given prefix directory. Also make sure that this given root dir
16 # exists.
17 prefix="${RBDEV_PREFIX:-/usr/local}"
19 # This directory is used to extract all files and to build everything in. It
20 # must not exist before this script is invoked (as a security measure).
21 builddir="${RBDEV_BUILD:-/tmp/rbdev-build}"
23 # This script needs to use GNU Make. On Linux systems, GNU Make is invoked
24 # by running the "make" command, on most BSD systems, GNU Make is invoked
25 # by running the "gmake" command. Set the "make" variable accordingly.
26 if [ -f "`which gmake 2>/dev/null`" ]; then
27 make="gmake"
28 else
29 make="make"
32 if [ -z $GNU_MIRROR ] ; then
33 GNU_MIRROR=http://mirrors.kernel.org/gnu
36 # These are the tools this script requires and depends upon.
37 reqtools="gcc bzip2 make patch makeinfo"
39 ##############################################################################
40 # Functions:
42 findtool(){
43 file="$1"
45 IFS=":"
46 for path in $PATH
48 # echo "Checks for $file in $path" >&2
49 if test -f "$path/$file"; then
50 echo "$path/$file"
51 return
53 done
56 input() {
57 read response
58 echo $response
61 #$1 file
62 #$2 URL"root
63 getfile() {
64 tool=`findtool curl`
65 if test -z "$tool"; then
66 tool=`findtool wget`
67 if test -n "$tool"; then
68 # wget download
69 echo "ROCKBOXDEV: Downloading $2/$1 using wget"
70 $tool -O $dlwhere/$1 $2/$1
72 else
73 # curl download
74 echo "ROCKBOXDEV: Downloading $2/$1 using curl"
75 $tool -Lo $dlwhere/$1 $2/$1
78 if [ $? -ne 0 ] ; then
79 echo "ROCKBOXDEV: couldn't download the file!"
80 echo "ROCKBOXDEV: check your internet connection"
81 exit
84 if test -z "$tool"; then
85 echo "ROCKBOXDEV: No downloader tool found!"
86 echo "ROCKBOXDEV: Please install curl or wget and re-run the script"
87 exit
92 build() {
93 toolname="$1"
94 target="$2"
95 version="$3"
96 patch="$4"
97 configure_params="$5"
98 needs_gmp="$6"
100 patch_url="http://www.rockbox.org/gcc"
102 case $toolname in
103 gcc)
104 file="gcc-core-$version.tar.bz2"
105 url="$GNU_MIRROR/gcc/gcc-$version"
108 binutils)
109 file="binutils-$version.tar.bz2"
110 url="$GNU_MIRROR/binutils"
114 echo "ROCKBOXDEV: Bad toolname $toolname"
115 exit
117 esac
119 # create build directory
120 if test -d $builddir; then
121 if test ! -w $builddir; then
122 echo "ROCKBOXDEV: No write permission for $builddir"
123 exit
125 else
126 mkdir -p $builddir
129 # download source tarball
130 if test ! -f "$dlwhere/$file"; then
131 getfile "$file" "$url"
134 # download patch
135 if test -n "$patch"; then
136 if test ! -f "$dlwhere/$patch"; then
137 getfile "$patch" "$patch_url"
141 cd $builddir
143 echo "ROCKBOXDEV: extracting $file"
144 tar xjf $dlwhere/$file
146 # do we have a patch?
147 if test -n "$patch"; then
148 echo "ROCKBOXDEV: applying patch $patch"
150 # apply the patch
151 (cd $builddir/$toolname-$version && patch -p1 < "$dlwhere/$patch")
153 # check if the patch applied cleanly
154 if [ $? -gt 0 ]; then
155 echo "ROCKBOXDEV: failed to apply patch $patch"
156 exit
160 # kludge to avoid having to install GMP and MPFR for new gcc
161 if test -n "$needs_gmp"; then
162 cd "gcc-$version"
163 if test ! -d gmp; then
164 echo "ROCKBOXDEV: Getting GMP"
165 if test ! -f $dlwhere/gmp-5.0.1.tar.bz2; then
166 getfile "gmp-5.0.1.tar.bz2" "$GNU_MIRROR/gmp"
168 tar xjf $dlwhere/gmp-5.0.1.tar.bz2
169 ln -s gmp-5.0.1 gmp
172 if test ! -d mpfr; then
173 echo "ROCKBOXDEV: Getting MPFR"
174 if test ! -f $dlwhere/mpfr-2.4.2.tar.bz2; then
175 getfile "mpfr-2.4.2.tar.bz2" "$GNU_MIRROR/mpfr"
177 tar xjf $dlwhere/mpfr-2.4.2.tar.bz2
178 ln -s mpfr-2.4.2 mpfr
180 cd $builddir
183 echo "ROCKBOXDEV: mkdir build-$toolname"
184 mkdir build-$toolname
186 echo "ROCKBOXDEV: cd build-$toolname"
187 cd build-$toolname
189 echo "ROCKBOXDEV: $toolname/configure"
190 ../$toolname-$version/configure --target=$target --prefix=$prefix --enable-languages=c --disable-libssp --disable-docs $configure_params
192 echo "ROCKBOXDEV: $toolname/make"
193 $make -j8
195 echo "ROCKBOXDEV: $toolname/make install"
196 $make install
198 rm -rf $builddir
201 ##############################################################################
202 # Code:
204 # Verify required tools
205 for t in $reqtools; do
206 tool=`findtool $t`
207 if test -z "$tool"; then
208 echo "ROCKBOXDEV: \"$t\" is required for this script to work."
209 echo "ROCKBOXDEV: Please install \"$t\" and re-run the script."
210 exit
212 done
214 echo "Download directory : $dlwhere (set RBDEV_DOWNLOAD to change)"
215 echo "Install prefix : $prefix (set RBDEV_PREFIX to change)"
216 echo "Build dir : $builddir (set RBDEV_BUILD to change)"
217 echo ""
219 # Verify download directory
220 if test -d "$dlwhere"; then
221 if ! test -w "$dlwhere"; then
222 echo "ROCKBOXDEV: No write permission for $dlwhere"
223 exit
225 else
226 mkdir $dlwhere
227 if test $? -ne 0; then
228 echo "ROCKBOXDEV: Failed creating directory $dlwhere"
229 exit
233 # Verify the prefix dir
234 if test ! -d $prefix; then
235 mkdir -p $prefix
236 if test $? -ne 0; then
237 echo "ROCKBOXDEV: Failed creating directory $prefix"
238 exit
241 if test ! -w $prefix; then
242 echo "ROCKBOXDEV: No write permission for $prefix"
243 exit
246 echo "Select target arch:"
247 echo "s - sh (Archos models)"
248 echo "m - m68k (iriver h1x0/h3x0, iaudio m3/m5/x5 and mpio hd200)"
249 echo "a - arm (ipods, iriver H10, Sansa, etc)"
250 echo "e - arm-eabi (same as above, new gcc toolchain)"
251 echo "i - mips (Jz4740 and ATJ-based players)"
252 echo "separate multiple targets with spaces"
253 echo "(Example: \"s m a\" will build sh, m86k and arm)"
254 echo ""
256 selarch=`input`
257 system=`uname -s`
259 # add target dir to path to ensure the new binutils are used in gcc build
260 PATH="$prefix/bin:${PATH}"
262 for arch in $selarch
264 echo ""
265 case $arch in
266 [Ss])
267 build "binutils" "sh-elf" "2.16.1"
268 build "gcc" "sh-elf" "4.0.3" "gcc-4.0.3-rockbox-1.diff"
271 [Ii])
272 build "binutils" "mipsel-elf" "2.17" "" "--disable-werror"
273 patch=""
274 if [ "$system" = "Interix" ]; then
275 patch="gcc-4.1.2-interix.diff"
277 build "gcc" "mipsel-elf" "4.1.2" "$patch"
280 [Mm])
281 build "binutils" "m68k-elf" "2.16.1"
282 patch=""
283 case $system in
284 CYGWIN* | Darwin | FreeBSD | Interix | SunOS)
285 patch="gcc-3.4.6.patch"
287 Linux)
288 machine=`uname -m`
289 if [ "$machine" = "x86_64" ]; then
290 patch="gcc-3.4.6-amd64.patch"
293 esac
294 build "gcc" "m68k-elf" "3.4.6" "$patch"
297 [Aa])
298 build "binutils" "arm-elf" "2.16.1"
299 build "gcc" "arm-elf" "4.0.3" "rockbox-multilibs-arm-elf-gcc-4.0.3_3.diff"
302 [Ee])
303 build "binutils" "arm-elf-eabi" "2.20.1"
304 build "gcc" "arm-elf-eabi" "4.4.4" "rockbox-multilibs-noexceptions-arm-elf-eabi-gcc-4.4.2_1.diff" "" "needs_gmp"
308 echo "ROCKBOXDEV: Unsupported architecture option: $arch"
309 exit
311 esac
312 done
314 echo ""
315 echo "ROCKBOXDEV: Done!"
316 echo ""
317 echo "ROCKBOXDEV: Make sure your PATH includes $prefix/bin"
318 echo ""